---
title: FileList
slug: Web/API/FileList
tags:
  - API
  - File API
  - Files
---
<div>{{APIRef("File API")}}{{gecko_minversion_header("1.9")}}</div>

<p>An object of this type is returned by the <code>files</code> property of the HTML {{HTMLElement("input")}} element; this lets you access the list of files selected with the <code>&lt;input type="file"&gt;</code> element. It's also used for a list of files dropped into web content when using the drag and drop API; see the <a href="/en-US/docs/DragDrop/DataTransfer" title="DragDrop/DataTransfer"><code>DataTransfer</code></a> object for details on this usage.</p>

<div class="note">
<p><strong>Note:</strong> Prior to {{Gecko("1.9.2")}}, the input element only supported a single file being selected at a time, meaning that the FileList would contain only one file. Starting with {{Gecko("1.9.2")}}, if the input element's multiple attribute is true, the FileList may contain multiple files.</p>
</div>

<h2 id="Using_the_file_list">Using the file list</h2>

<p>All <code>&lt;input&gt;</code> element nodes have a <code>files</code> attribute of type <code>FileList</code> on them which allows access to the items in this list. For example, if the HTML includes the following file input:</p>

<pre>&lt;input id="fileItem" type="file"&gt;
</pre>

<p>The following line of code fetches the first file in the node's file list as a <a href="/en-US/docs/DOM/File" title="DOM/File"><code>File</code></a> object:</p>

<pre class="brush: js">var file = document.getElementById('fileItem').files[0];
</pre>

<h2 id="Method_overview">Method overview</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<td><code>File <a href="#item()">item</a>(index);</code></td>
		</tr>
	</tbody>
</table>

<h2 id="Attributes">Properties</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<td class="header">Attribute</td>
			<td class="header">Type</td>
			<td class="header">Description</td>
		</tr>
		<tr>
			<td><code>length</code></td>
			<td><code>integer</code></td>
			<td>A read-only value indicating the number of files in the list.</td>
		</tr>
	</tbody>
</table>

<h2 id="Methods">Methods</h2>

<h3 id="item()">item()</h3>

<p>Returns a <a href="/en-US/docs/DOM/File" title="DOM/File"><code>File</code></a> object representing the file at the specified index in the file list.</p>

<pre> File item(
   index
 );
</pre>

<h6 id="Parameters">Parameters</h6>

<dl>
	<dt><code>index</code></dt>
	<dd>The zero-based index of the file to retrieve from the list.</dd>
</dl>

<h6 id="Return_value">Return value</h6>

<p>The <a href="/en-US/docs/DOM/File" title="DOM/File"><code>File</code></a> representing the requested file.</p>

<h2 id="Example">Example</h2>

<p>This example iterates over all the files selected by the user using an <code>input</code> element:</p>

<pre class="brush:js">// fileInput is an HTML input element: &lt;input type="file" id="myfileinput" multiple&gt;
var fileInput = document.getElementById("myfileinput");

// files is a FileList object (similar to NodeList)
var files = fileInput.files;
var file;

// loop through files
for (var i = 0; i &lt; files.length; i++) {

    // get item
    file = files.item(i);
    //or
    file = files[i];

    alert(file.name);
}
</pre>

<p>Here is a complete example.</p>

<pre class="brush:html">&lt;!DOCTYPE HTML&gt;
&lt;html&gt;
&lt;head&gt;
&lt;/head&gt;
&lt;body&gt;
&lt;!--multiple is set to allow multiple files to be selected--&gt;

&lt;input id="myfiles" multiple type="file"&gt;

&lt;/body&gt;

&lt;script&gt;

var pullfiles=function(){
    // love the query selector
    var fileInput = document.querySelector("#myfiles");
    var files = fileInput.files;
    // cache files.length
    var fl = files.length;
    var i = 0;

    while ( i &lt; fl) {
        // localize file var in the loop
        var file = files[i];
        alert(file.name);
        i++;
    }
}

// set the input element onchange to call pullfiles
document.querySelector("#myfiles").onchange=pullfiles;

//a.t
&lt;/script&gt;

&lt;/html&gt;</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName('File API', '#filelist-section', 'FileList')}}</td>
			<td>{{Spec2('File API')}}</td>
			<td> </td>
		</tr>
		<tr>
			<td>{{SpecName('HTML WHATWG', '#concept-input-type-file-selected', 'selected files')}}</td>
			<td>{{Spec2('HTML WHATWG')}}</td>
			<td> </td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.FileList")}}</p>


<h2 id="See_also">See also</h2>

<ul>
	<li><a href="/en-US/docs/Using_files_from_web_applications" title="Using files from web applications">Using files from web applications</a></li>
	<li><code><a href="/en-US/docs/DOM/File" title="DOM/File">File</a></code></li>
	<li><code><a href="/en-US/docs/DOM/FileReader" title="DOM/FileReader">FileReader</a></code></li>
</ul>
